var jsonFile = FileLib.read("./config/ChatTriggers/modules/VzDailyStats/vzDailyStats.json");
var vzDailyStats = JSON.parse(jsonFile);
var currentDate = new Date().getDate();

var VampireZDailyStatsShown = true;

TriggerRegister.registerCommand("toggleVZstats").setName("vzdailystats");
TriggerRegister.registerCommand("toggleVZstats").setName("vzstats");
TriggerRegister.registerCommand("toggleVZstats").setName("vzstat");
/* Creating a command with multiple syntaxes */
function toggleVZstats(argument) {
	if (argument === "show") {
		VampireZDailyStatsShown = true;
		ChatLib.chat("&r&aYour VampireZ daily stats are now shown!&r");
		ChatLib.chat("&2&oDrag it around your screen to fit your needs &2&oand right click &2&oit &2&oto change &2&oits colors!");
	}                                                            
	else if (argument === "hide") {
		VampireZDailyStatsShown = false;
		ChatLib.chat("&r&cYour VampireZ daily stats are now hidden!&r");
	}
	else if (argument === "reset") {
		FileLib.write('./config/ChatTriggers/modules/VzDailyStats/vzDailyStats.json',
						'{"survivor wins":0,"survivor kills":0,"vampire kills":0,"zombie kills":0,"coins":0,"date written in the JSON":' + currentDate + '}');
		vzDailyStats["survivor wins"] = 0;
		vzDailyStats["survivor kills"] = 0;
		vzDailyStats["vampire kills"] = 0;
		vzDailyStats["zombie kills"] = 0;
		vzDailyStats["coins"] = 0;
		vzDailyStats["date written in the JSON"] = currentDate;
		ChatLib.chat("&4Your VampireZ daily stats are now reset!&r");
	}
	else {
		ChatLib.chat("&cUsage: /vzdailystats <show|hide|reset>");
	}
}

TriggerRegister.registerChat("incrementSurvivorWins").setChatCriteria("&r&eWinning Team&r&7 - &r&bSurvivors&r").setParameter("contains");
function incrementSurvivorWins() {
	/* Checking that the user has a Human scoreboard at the end of the game to avoid Vamp-players from gaining +1 Human win if Humans won and he was a vamp */
	if (Scoreboard.getLines().size() > 10 && Scoreboard.getLineByIndex(8).toString().contains("Vampire Kills:")) { 
		vzDailyStats["survivor wins"]++;
	}
}

/* Multiple variants for each rank color */
TriggerRegister.registerChat("incrementSurvivorKills").setChatCriteria("${killed_survivor} was finished off by a Zombie after fighting &r&b${name_of_vampire}&r&e and became a vampire!&r").setParameter("contains");
TriggerRegister.registerChat("incrementSurvivorKills").setChatCriteria("${killed_survivor} was finished off by a Zombie after fighting &r&6${name_of_vampire}&r&e and became a vampire!&r").setParameter("contains");
TriggerRegister.registerChat("incrementSurvivorKills").setChatCriteria("${killed_survivor} was finished off by a Zombie after fighting &r&a${name_of_vampire}&r&e and became a vampire!&r").setParameter("contains");
TriggerRegister.registerChat("incrementSurvivorKills").setChatCriteria("${killed_survivor} was finished off by a Zombie after fighting &r&7${name_of_vampire}&r&e and became a vampire!&r").setParameter("contains");
TriggerRegister.registerChat("incrementSurvivorKills").setChatCriteria("${killed_survivor}&r&e was killed by &r&b${name_of_vampire}&r&e and became a vampire!&r").setParameter("contains");
TriggerRegister.registerChat("incrementSurvivorKills").setChatCriteria("${killed_survivor}&r&e was killed by &r&6${name_of_vampire}&r&e and became a vampire!&r").setParameter("contains");
TriggerRegister.registerChat("incrementSurvivorKills").setChatCriteria("${killed_survivor}&r&e was killed by &r&a${name_of_vampire}&r&e and became a vampire!&r").setParameter("contains");
TriggerRegister.registerChat("incrementSurvivorKills").setChatCriteria("${killed_survivor}&r&e was killed by &r&7${name_of_vampire}&r&e and became a vampire!&r").setParameter("contains");
function incrementSurvivorKills(killed_survivor, name_of_vampire) {
	/*Check if the killing vampire is the user*/
	/* getDisplayName() is used to ensure the mod continues to work even if the user is nicked */
	if (name_of_vampire === World.getAllPlayers().get(0).getDisplayName().getText().replace("\u00A7c", "")) { /* "\u00A7" is the Java source code for the Section Sign  */
		vzDailyStats["survivor kills"]++;
	}
}

TriggerRegister.registerChat("incrementVampireKills").setChatCriteria("&r&eYou killed a vampire!&r").setParameter("contains");
function incrementVampireKills() {
		vzDailyStats["vampire kills"]++
}

/* Every zombie kill gives precisely 2 gold */
TriggerRegister.registerChat("incrementZombieKills").setChatCriteria("&r&6+2 gold!&r").setParameter("contains");
function incrementZombieKills() {
	if (Math.floor(Math.random() * 11) <= 8) { /* Removing the 20% of Zombie Doubler IV */
		vzDailyStats["zombie kills"]++;
	}
}

TriggerRegister.registerChat("incrementCoins").setChatCriteria("&6+${amount_of_coins} coins").setParameter("contains");
function incrementCoins(amount_of_coins) {
	/* The "+Nb coins" message is widely used throughout Hypixel but we don't want Bliz or TNT coins to be counted towards our vz stats mod so 
	we check whether the user is in a VampireZ game by looking at the scoreboard title */
	if (ChatLib.removeFormatting(Scoreboard.getTitle()) === "VAMPIREZ") {
		vzDailyStats["coins"] = vzDailyStats["coins"] + Number(amount_of_coins);
	}
}

/* The daily stats are stored in an external JSON file in order to ensure that the stats aren't reset at every minecraft/chattriggers reload */
register("gameUnload", function updateVampirezJSON() {
	/* Save the data stored in the vzDailyStats object by writing it on the JSON file */
	FileLib.write('./config/ChatTriggers/modules/VzDailyStats/vzDailyStats.json',
	'{"survivor wins":' + vzDailyStats["survivor wins"] + ',"survivor kills":' + vzDailyStats["survivor kills"] 
	+ ',"vampire kills":' + vzDailyStats["vampire kills"] + ',"zombie kills":' + vzDailyStats["zombie kills"] + ',"coins":' 
	+ vzDailyStats["coins"] + ',"date written in the JSON":' + vzDailyStats["date written in the JSON"] + '}');
	jsonFile = FileLib.read("./config/ChatTriggers/modules/VzDailyStats/vzDailyStats.json");
	vzDailyStats = JSON.parse(jsonFile);
});

register("gameLoad", function resetVampirezStatsOfPreviousDay() {
	if (currentDate != vzDailyStats["date written in the JSON"]) {
		FileLib.write('./config/ChatTriggers/modules/VzDailyStats/vzDailyStats.json',
					'{"survivor wins":0,"survivor kills":0,"vampire kills":0,"zombie kills":0,"coins":0,"date written in the JSON":' + currentDate + '}');
		vzDailyStats["survivor wins"] = 0;
		vzDailyStats["survivor kills"] = 0;
		vzDailyStats["vampire kills"] = 0;
		vzDailyStats["zombie kills"] = 0;
		vzDailyStats["coins"] = 0;
		vzDailyStats["date written in the JSON"] = currentDate;
	}
});

xPosOfVampirezStats = Number(FileLib.read('./config/ChatTriggers/modules/VzDailyStats/savedXPosOfVampirezStats.txt'))
yPosOfVampirezStats = Number(FileLib.read('./config/ChatTriggers/modules/VzDailyStats/savedYPosOfVampirezStats.txt'))

/* The color code values are doubled because the function(mouseX, mouseY, mouseButton) double-clicks */
colorCode = ["0", "0", "8", "8", "7", "7", "f", "f", "5", "5", "d", "d", "9", "9", "1", "1", "3", "3", "b", "b", "a", "a", "2", "2", "6", "6", "e", "e", "c", "c", "4", "4"];
var vzn = 7; /* the default value is the second "f" of the colorCode array */

register("renderOverlay", function renderingStatsOnScreen() {
	if (VampireZDailyStatsShown) {
		Renderer.drawStringWithShadow("&" + colorCode[vzn] + "&l&nVampireZ Daily Stats", xPosOfVampirezStats, yPosOfVampirezStats);
		Renderer.drawStringWithShadow("&" + colorCode[vzn] + "Human Wins: " + vzDailyStats["survivor wins"], xPosOfVampirezStats, yPosOfVampirezStats+10);
		Renderer.drawStringWithShadow("&" + colorCode[vzn] + "Vampire Kills: " + vzDailyStats["vampire kills"], xPosOfVampirezStats, yPosOfVampirezStats+20);
		Renderer.drawStringWithShadow("&" + colorCode[vzn] + "Zombie Kills: " + vzDailyStats["zombie kills"], xPosOfVampirezStats, yPosOfVampirezStats+30);
		Renderer.drawStringWithShadow("&" + colorCode[vzn] + "Human Kills: " + vzDailyStats["survivor kills"], xPosOfVampirezStats, yPosOfVampirezStats+40);
		Renderer.drawStringWithShadow("&" + colorCode[vzn] + "Coins: " + vzDailyStats["coins"], xPosOfVampirezStats, yPosOfVampirezStats+50);
	}
});

var clickedAtTheVzText = false;
register("clicked", function(mouseX, mouseY, mouseButton) {
	if (Client.isInChat()) {
		if (mouseButton === 0) { /* left click */
			if (xPosOfVampirezStats <= mouseX && mouseX < xPosOfVampirezStats + 60 && yPosOfVampirezStats <= mouseY && mouseY < yPosOfVampirezStats+45) { /* check that the text is clicked */
				clickedAtTheVzText = true;
			}
			else {
				clickedAtTheVzText = false;
			}
		}
		else if (mouseButton === 1) { /* right click */ 
			if (xPosOfVampirezStats <= mouseX && mouseX < xPosOfVampirezStats + 60 && yPosOfVampirezStats <= mouseY && mouseY < yPosOfVampirezStats+45) {
				if (0 <= vzn && vzn < 32) {
					vzn++;
				}
				if (vzn === 32) {
					vzn = 0;
				}
			}
		}
	}
});
register("dragged", function(dx, dy) {
	if (Client.isInChat()) {
		if (clickedAtTheVzText) {
			xPosOfVampirezStats += dx
			yPosOfVampirezStats += dy
		}
	}
});

register("gameUnload", function saveCoordsOfVZStats() {
	FileLib.write('./config/ChatTriggers/modules/VzDailyStats/savedXPosOfVampirezStats.txt', xPosOfVampirezStats);
	FileLib.write('./config/ChatTriggers/modules/VzDailyStats/savedYPosOfVampirezStats.txt', yPosOfVampirezStats);
});